<template>
  <div class="p-4">
    <clock
      :minute="selected.minute"
      :hour="selected.hour"
      @hour-input="selected.hour = $event"
      @minute-input="selected.minute = $event"
    />

    <div class="flex flex-row items-center justify-end self-stretch mt-8">
      <div>
        <button
          @click="$emit('cancel')"
          class="button mr-8 bg-transparent text-blue-500 normal-case text-sm tracking-wider hover:bg-blue-100 active:bg-blue-200"
        >
          Cancel
        </button>
        <button @click="submit()" class="button">Ok</button>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { reactive, ref } from "@vue/reactivity";
import CircleSelect from "./CircleSelect.vue";
import { watchedRef } from "@/use/watchedRef";
import Clock from "./Clock.vue";
import { DateTime } from "luxon";

export default {
  components: { CircleSelect, Clock },
  props: {
    value: {
      type: DateTime,
      required: true
    }
  },
  emits: ["input", "cancel"],
  setup(props, context) {
    const selected = reactive({
      hour: watchedRef(() => props.value.hour),
      minute: watchedRef(() => props.value.minute)
    });
    return {
      current: ref("hour"),
      selected,
      submit: () => {
        context.emit("input", DateTime.fromObject(selected));
      }
    };
  }
};
</script>

<style></style>
